'*******************************************************************************
'Programm for Display ST7735R 1.8Zoll 128x160
'         and Display ILI9163 1.8Zoll 128x160
'Bascom IDE 2.0.7.7
'
'Version:13012014
'By Hkipnik
'  Copyright by H.Kipnik 2012
'Date 13.01.2014
'*******************************************************************************
$nocompile


Const Transparent = &H1000

Const Red = &HF800
Const Green = &H07E0
Const Blue = &H001F
Const White = &HFFFF
Const Black = &H0000
Const Yellow = &HFFE0
Const Cyan = &H0410
Const Magenta = &H8010
Const Brown = &HFC00
Const Olive = &H8400
Const Light_gray = &H8410
Const Dark_gray = &H4208
Const Light_blue = &H841F
Const Light_green = &H87F0
Const Light_cyan = &H87FF
Const Light_red = &HFC10
Const Gray1 = &HC618
Const Gray2 = &HA514
Const Gray3 = &H630C
Const Gray4 = &H4208
Const Gray5 = &H2104
Const Gray6 = &H3186
Const Blue0 = &H1086
Const Blue1 = &H3188
Const Blue2 = &H4314
Const Blue3 = &H861C
Const Cyan0 = &H3D34
Const Cyan1 = &H1DF7
Const Green0 = &H0200
Const Green1 = &H0208

Declare Sub Lcd_init()
Declare Sub Lcd_write_command(byval Command As Byte)
Declare Sub Lcd_write_data(byval Da_ta As Byte)
Declare Sub Lcd_write_color(byval Color As Word)
Declare Sub Lcd_set_window(byval Xs As Byte , Byval Ys As Byte , Byval Xe As Byte , Byval Ye As Byte)
Declare Sub Lcd_clear(byval Color As Word)
Declare Sub Lcd_set_pixel(byval X As Byte , Byval Y As Byte , Byval Color As Word)
Declare Sub Lcd_text(byval S As String , Byval Xoffset As Byte , Byval Yoffset As Byte , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word )
Declare Sub Lcd_line(byval X1 As Byte , Byval Y1 As Byte , Byval X2 As Byte , Byval Y2 As Byte , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_fill_circle(byval X As Byte , Byval Y As Byte , Byval Radius As Byte , Byval Color1 As Word)


Declare Sub Lcd_circle(byval X As Byte , Byval Y As Byte , Byval Radius As Byte , Byval Color As Word)
Declare Sub Lcd_box(byval Xstart As Byte , Byval Ystart As Byte , Byval X_length As Byte , Byval Y_height As Byte , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)

'Declare Sub Lcd_pic_rom(byval Xs As Byte , Byval Ys As Byte , Byval Breite As Byte , Byval Height As Byte)

#if Sdcard = 1
Declare Sub Lcd_pic(byval Xs As Byte , Byval Ys As Byte , Byval Breite As Byte , Byval Height As Byte , Byval Bnama As String)
Dim Rgb_data(320) As Byte
#endif
Dim Hoehe As Byte
Dim Breit As Byte

Dim Rgb_16 As Word
Dim Rgb16_low As Byte At Rgb_16 Overlay
Dim Rgb16_high As Byte At Rgb_16 + 1 Overlay
Dim Temp As Byte